#! /bin/bash

CONTAINER_DIR=$( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )

HOME=${CONTAINER_DIR}/..
DEST=${CONTAINER_DIR}/solver

if [ -d ${DEST} ]; then
    rm -r ${DEST}
fi

mkdir ${DEST}

cp -v -r ${HOME}/src ${DEST}/
cp -v -r ${HOME}/test ${DEST}/
cp -v -r ${HOME}/test_bench ${DEST}/
cp -v ${HOME}/Makefile ${DEST}/
cp -v ${HOME}/requirements.txt ${DEST}/

docker build -f Dockerfile -t solver .

rm -r ${DEST}
