# baseline solution

from sys import stdin

from instance import Instance

if __name__ == '__main__':
    problem = Instance.read_DIMACS(stdin)

    from graphillion import GraphSet

    vertices = set(u for u, _ in problem.E) | set(v for _, v in problem.E)

    if problem.s is None:
        s, t = -1, -2

        for v in vertices:
            problem.E.append((s, v))

        for v in vertices:
            problem.E.append((v, t))
        
        problem.L += 2

        GraphSet.set_universe(problem.E)
        print((len(GraphSet.paths(s, t).smaller(problem.L + 1)) - len(vertices)) // 2)
    else:
        s = problem.s
        t = problem.t

        GraphSet.set_universe(problem.E)
        print(len(GraphSet.paths(s, t).smaller(problem.L + 1)))

