from argparse import ArgumentParser
from random import randint, sample, shuffle

import networkx

parser = ArgumentParser()
parser.add_argument('--all-pairs', action='store_true')
args = parser.parse_args()

n = randint(2, 10)
m = randint(n - 1, n * (n - 1) // 2)

while True:
    E = [(u, v) for u in range(1, n + 1) for v in range(1, u)]
    shuffle(E)
    E = E[:m]

    G = networkx.Graph()
    G.add_nodes_from(range(1, n + 1))
    G.add_edges_from(E)

    if len(list(networkx.connected_components(G))) == 1:
        break

l = randint(1, n)

print(f'p edge {n} {m}')
for u, v in E:
    print(f'e {u} {v}')
print(f'l {l}')

if not args.all_pairs:
    s, t = sample(range(1, n + 1), 2)
    print(f't {s} {t}')